#include "Index.h"
#include <string>
#include <sstream>
#include <vector>
#include <iostream>
#include <fstream>
#include <algorithm>
#include <cctype>
using namespace std;

string cleanword( string word );

Index :: Index( string textfname, string keywordfname){   
    //read keywords
    ifstream keywords( keywordfname.c_str() );
    string word;
    while( keywords >> word ){
        index[ word ] = vector<int>();
    }
    
    //read text
    ifstream text( textfname.c_str() );
    string line;
    long linenr = 0L;
    while( getline(text, line)){
        //process line
        line = line.substr(0, line.length()-1);
        ++linenr;
        string word;
        stringstream ss( line );
        while( ss >> word){
            word = cleanword( word );
            //cout<<word<<endl;
            map<string, vector<int> > :: iterator it;
            it = index.find( word );
            if( it != index.end() ){
                vector<int>& v = it->second;
                if( v.size() ==0 || v.size()> 0 && v[ v.size() -1 ] != linenr ){
                    v.push_back( linenr);
                }
            }
        }
    }
    
}


string cleanword( string word ){
    transform( word.begin(), word.end(), word.begin(), ::tolower );
    stringstream ss("");
    for( char c: word ){
        if (c>='a' && c<='z'){
            ss<<c;
        } 
    }
    string newword;
    ss>>newword;
    return newword;
}


void Index :: printIndex( ostream& os ){
     map<string, vector<int> > :: iterator it;
     for( it = index.begin(); it != index.end(); ++it){
         
         vector<int>& v = it->second;
         if( v.size()>0){
            cout<<it->first<<"\t";
         }else{
             continue;
         }
         
         cout<<v[0];
         int counter = 0;
         for( int i=1; i<v.size(); ++i){
             //intervallumon belul
             if( v[i] == v[i-1] +1 ){
                 ++counter;
                 continue;
             }else{
                //intervallum vege
                 if( counter >0 ){
                    cout<<"-"<<v[i-1];
                 }
                 cout<<", "<<v[i];
                 
                 counter = 0;
             }
             
         }
         if( counter >0 ){
                    cout<<"-"<<v[v.size()-1];
         }
         cout<<endl;
         
         
         
     }
}
